Introduction
============

This program implements the method introduced by [De Guispert et *al*](http://link.springer.com/content/pdf/10.1007%2Fs10590-012-9132-2.pdf)
to compute the posterior probabilities of a translation
hypothesis. For a given source sentence, the *n*-gram posterior
probabilities quantifies the probability for a given *n*-gram to be
part of the system output.


Installation
============

You have to install first:

* [openfst](http://www.openfst.org/twiki/bin/view/FST/WebHome) (version 1.3.3) 
* [boost](http://www.boost.org/) (version 1.54.0) 

You should then update the Makefile to reflect the directories these
library have been installed to. `make all` will then compile the main
program `ngrampost`.

Usage
=====

The program takes as input a lattice respecting the following constraints:

* compiled lattice in which input and output symbols are kept
* weight on the edges must be `-log p` where p is the score this edge
  contributes to

Posteriors are output as a dictionary stored in a json file that
associates each *n*-gram to its posterior probability.

Useful commands
===============

To add the NULL to the symbol tables:

    :::bash
    for i in `ls *.symb.txt`; do sed -i "1iNULL 0" $i; done

To compile all the fst in a directory:

    :::bash
    for i in `ls *.fst.txt`; do fstcompile --arc_type=log --osymbols=$(echo $i | sed "s/.fst.txt/.symb.txt/") --isymbols=$(echo $i | sed "s/.fst.txt/.symb.txt/") --keep_osymbols --keep_isymbols $i > $(echo $i|sed "s/.txt//"); done

To compute all the posterios in parallel using [ppss](https://code.google.com/p/ppss/):

    :::bash
    ./ppss -p 10 -c './ngrampost -i $ITEM -o $ITEM.posteriors -n 10000 ' -d /people/wisniews/workspace/wmt-13-quality-estimation/fst/task1-3.train/
