/* 
 * File:   ngrampost.h
 * Author: Francois Yvon, Anil Kumar Singh and Guillaume Wisniewski
 *
 * Created on December 6, 2012, 9:11 AM
 */

#ifndef NGRAMPOST_H
#define	NGRAMPOST_H

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>
#include <omp.h>
#include <math.h>
#include <string>
#include <vector>

#include <fst/fst.h>
#include <fst/fstlib.h>
#include <fst/mutable-fst.h>
#include <fst/script/fstscript.h>

#include <boost/log/trivial.hpp>

#define BOOST_ALL_DYN_LINK

using namespace std;
using namespace fst;
using namespace fst::script;

using fst::SymbolTable;
        
typedef map<int, LogWeight> AMap;
typedef map<int, AMap> NMap;    
    
typedef AMap::iterator AMapItr;
typedef NMap::iterator NMapItr;


bool normalizeFST(VectorFst<LogArc>& ngramLatticeFst, VectorFst<LogArc>& normalizedFst);

int computePosteriors(VectorFst<LogArc>& normalizedFst, AMap& alphas, NMap& ngramAlphas,
        AMap& posteriors);

void savePosteriors(AMap& posteriors, VectorFst<LogArc>& normalizedFst, string& output_file);
#endif	/* NGRAMPOST_H */

